!!
!! JPLEPH_de405 generator
!!
!! parameter: lfn -- file unit
!!            HD% -- rinex head structure, see `rinex_observation.h`
!!            ierr -- error code
!!
!! author   : Ge Maorong
!! 
!! last mod.: 31-May-2003, CLEAN
!!

       program de405
       implicit none
       INCLUDE 'jpleph.h'
       TYPE(JPLEPH_HEADER) HD
!
!! local variables
      LOGICAL KM,BARY,FIRST
      INTEGER*4 NRECL,KSIZE,NRL,NR,I,J,K,LFN,IRECSZ,lfn1,lfnb,lfnb1
      integer*4 ioerr,flag,ii,kk,jj,jjj
      integer*4 nargs
      character*30  jpleph,header,jpleph1
      character*80 line,msg
      real*8 BUF(1500)
!
!! read arguments
nargs=iargc()
if(nargs.lt.1) then
  write(*,'(a)') 'Usage: de405 jpleph'
  call exit(1)
endif
call getarg(1,header)
call getarg(2,jpleph)
call getarg(3,jpleph1)
!
!! read jpleph_405 header
        lfn=10   !! input file header
        lfnb=30  !! input file body
        lfnb1=40 !! input file body2
        lfn1=20  !! output file
        OPEN(lfn,FILE=header,STATUS='OLD',err=200)  !! jpleph header
        OPEN(lfnb,FILE=jpleph,STATUS='OLD',err=200) !! jpleph body part(1980-2000)
        OPEN(lfnb1,FILE=jpleph1,STATUS='OLD',err=200) !! jpleph body part2(2000-2020)
        NRECL=4
        KSIZE=2036
        IRECSZ=NRECL*KSIZE 
        OPEN(lfn1,FILE='jpleph_de405',ACCESS='DIRECT',RECL=IRECSZ,STATUS='NEW',err=200)
        do while(.true.)    
          msg=''
          read(lfn,'(a)',end=400) line
          if(index(line(1:5),'GROUP').ne.0) then
             read(line,'(6x,i7)',iostat=ioerr) flag
             if(ioerr.ne.0) msg='read jpl error'
             if(flag.eq.1010) then
             elseif(flag.eq.1030) then
                read(lfn,'(a)',end=200) line
                read(line,'(3f12.2)',iostat=ioerr) (HD%SS(i),i=1,3)
                if(ioerr.ne.0) msg='read jpl header error: SS'
             elseif(flag.eq.1040) then
                line=''
                read(lfn,'(a)',end=200) line
                read(line,'(i6)',end=200) HD%NCON
                if(mod(HD%NCON,10).eq.0) then
                   ii = HD%NCON/10
                else
                   ii=HD%NCON/10+1
                endif
                do i=1,ii
                   read(lfn,'(a)',end=200) line
                   read(line,'(10(2x,a6))',iostat=ioerr) (HD%CNAM(jj),jj=1+(i-1)*10,10+(i-1)*10)
                   if(ioerr.ne.0) msg='read jpl header error: CNAM'
                enddo
                HD%AU=149597870.691d0
                HD%EMRAT=81.30056d0
		HD%NUMDE=405
             elseif(flag.eq.1041) then
                read(lfn,'(a)',end=200) line
                read(line,'(i6)',end=200) HD%NCON
                if(mod(HD%NCON,3).eq.0) then
                   ii = HD%NCON/3
                else
                   ii=HD%NCON/3+1
                endif
                do i=1,ii
                   read(lfn,'(a)',end=200) line
                   read(line,'(3f26.18)',iostat=ioerr) (HD%CVAL(jj),jj=1+(i-1)*3,3+(i-1)*3)
                   if(ioerr.ne.0) msg='read jpl header error: CVAL'
                enddo
             elseif(flag.eq.1050) then
                read(lfn,'(a)',end=200) line
                read(line,'(13i6)',iostat=ioerr,end=200) (HD%IPT(1,jj),jj=1,13)
                if(ioerr.ne.0) msg='read jpl header error: IPT'
                read(lfn,'(a)',end=200) line
                read(line,'(13i6)',iostat=ioerr,end=200) (HD%IPT(2,jj),jj=1,13)
                if(ioerr.ne.0) msg='read jpl header error: IPT'
                read(lfn,'(a)',end=200) line
                read(line,'(13i6)',iostat=ioerr,end=200) (HD%IPT(3,jj),jj=1,13)
                if(ioerr.ne.0) msg='read jpl header error: IPT'
             elseif(flag.eq.1070) then
             endif
          elseif(index(line,'END OF HEADER').ne.0) then
            write(lfn1,REC=1) HD%CNAM,HD%SS,HD%NCON,HD%AU,HD%EMRAT, &
                              ((HD%IPT(I,J),I=1,3),J=1,12),HD%NUMDE,(HD%IPT(I,13),I=1,3)
            write(LFN1,REC=2) HD%CVAL
            exit
          endif
        enddo
          !!! output body1(1980-2000)
        400 do while(.true.)
             read(lfnb,'(a)',end=500) line
             read(line,'(i6,i6)') ii,jj
             if(mod(jj,3).eq.0) then
                jjj = jj/3
             else
                jjj=jj/3+1
             endif
             do i=1,jjj     
               read(lfnb,'(a)',end=500) line           
               read(line,'(3f26.18)',err=100) (buf(kk),kk=1+(i-1)*3,3+(i-1)*3) 
             enddo 
             write(LFN1,REC=ii+2) (BUF(K),K=1,jj) 
	  enddo
          !!! output body2(2000-2020)
         500 do while(.true.)
             read(lfnb1,'(a)',end=300) line
             read(line,'(i6,i6)') ii,jj
             if(mod(jj,3).eq.0) then
                jjj = jj/3
             else
                jjj=jj/3+1
             endif
             do i=1,jjj     
               read(lfnb1,'(a)',end=300) line           
               read(line,'(3f26.18)',err=100) (buf(kk),kk=1+(i-1)*3,3+(i-1)*3) 
             enddo 
             write(LFN1,REC=ii+2+229) (BUF(K),K=1,jj) 
	  enddo  
          if(len_trim(msg).ne.0) then
               write(*,'(a)') '***ERROR: '//msg
               call exit(1)
          endif

  100 WRITE(*,'(a)') '***ERROR(jpleph_state):read `header` '
      call exit(1)

  200 WRITE(*,'(a)') '***ERROR(jpleph_state): open `jpleph_de405` '
      call exit(1)

  300 close(10)
      close(20)
      close(30)

stop
end
